package com.commtrain.PMS.application;

import org.apache.log4j.Logger;
import org.jpos.iso.*;

import com.commtrain.PMS.iso.filter.HypercomFilter;
import com.commtrain.PMS.transaction.*;

public class HypercomApplication extends Application {

	private static Logger logger = Logger.getLogger(HypercomApplication.class);
	
    /**
    * Constructor.
    */
    public HypercomApplication() {
        super(HYPERCOM_ID);
        filter = new HypercomFilter();
    }

    public ISOMsg processTransaction(ISOMsg m){
    	 		
    	 Transaction transaction = Transaction.getInstance(this, m);
    	
	    	 
    	ISOMsg response = null;

    	try{
	    	if(transaction!=null)
	    		response = transaction.process();
    	}catch(Throwable e){
       		logger.error("Stack Trace", e);
    	}
    	return response;
    }
}
