package com.commtrain.PMS.iso;

import org.jpos.iso.ISOFieldPackager;
import org.jpos.iso.ISOMsg;
import org.jpos.iso.ISOPackager;

/**
 * 
 */
public class AdditionalDataItemDefinition {
    /**
     * field number
     */
    private int fldno;
    
    /**
     * table id
     */
    private String tableID;
    
    /**
     * description
     */
    private String description;

    /**
     * this object is used to create new ISOMsg by cloning
     */
    private ISOMsg isoMsg;
    
    /**
     * item packager for ISOMsg objects
     */
    private ISOPackager isoPackager;

    /**
     * item packager for ISOField objects
     */
    private ISOFieldPackager fieldPackager;

    /**
     * Default constructor.
     */
    public AdditionalDataItemDefinition() {
        super();
    }

    /**
     * Object constructor.
     * @param fldno field number
     * @param tableID table id
     * @param description description
     * @param isoMsg this object is used to create new ISOMsg by cloning
     * @param isoPackager item packager for ISOMsg objects
     * @param fieldPackager item packager for ISOField objects
     */
    public AdditionalDataItemDefinition(
            int fldno,
            String tableID,
            String description,
            ISOMsg isoMsg,
            ISOPackager isoPackager,
            ISOFieldPackager fieldPackager) {
        super();
        this.fldno = fldno;
        this.tableID = tableID;
        this.description = description;
        this.isoMsg = isoMsg;
        this.isoPackager = isoPackager;
        this.fieldPackager = fieldPackager;
    }

    /**
     * Returns the fldno.
     * @return int
     */
    public int getFldno() {
        return fldno;
    }

    /**
     * Sets the fldno.
     * @param fldno The fldno to set
     */
    public void setFldno(int fldno) {
        this.fldno = fldno;
    }

    /**
     * Returns the tableID.
     * @return String
     */
    public String getTableID() {
        return tableID;
    }

    /**
     * Sets the tableID.
     * @param tableID The tableID to set
     */
    public void setTableID(String tableID) {
        this.tableID = tableID;
    }

    /**
     * Returns the description.
     * @return String
     */
    public String getDescription() {
        return description;
    }

    /**
     * Sets the description.
     * @param description The description to set
     */
    public void setDescription(String description) {
        this.description = description;
    }

    /**
     * Returns the isoMsg.
     * @return ISOMsg
     */
    public ISOMsg getIsoMsg() {
        return isoMsg;
    }

    /**
     * Sets the isoMsg.
     * @param isoMsg The isoMsg to set
     */
    public void setIsoMsg(ISOMsg isoMsg) {
        this.isoMsg = isoMsg;
    }

    /**
     * Returns the isoPackager.
     * @return ISOPackager
     */
    public ISOPackager getIsoPackager() {
        return isoPackager;
    }

    /**
     * Sets the isoPackager.
     * @param isoPackager The isoPackager to set
     */
    public void setIsoPackager(ISOPackager isoPackager) {
        this.isoPackager = isoPackager;
    }

    /**
     * Returns the fieldPackager.
     * @return ISOFieldPackager
     */
    public ISOFieldPackager getFieldPackager() {
        return fieldPackager;
    }

    /**
     * Sets the fieldPackager.
     * @param fieldPackager The fieldPackager to set
     */
    public void setFieldPackager(ISOFieldPackager fieldPackager) {
        this.fieldPackager = fieldPackager;
    }
}
