package com.commtrain.PMS.iso;

import org.jpos.iso.ISOException;
import org.jpos.iso.ISOMsg;

/**
 * 
 */
public class CVV2Data extends ISOMsg {
    /**
     * the table id of CVV2Data ("16")
     */
    public static final String TABLE_ID = "16";

    /**
     * the field number of CVV2Data (16)
     */
    public static final int FIELD_NUMBER = 16;


    /**
     * the field number of flag1 (0)
     */
    private static final int FLAG_1 = 0;

    /**
     * the field number of flag2 (1)
     */
    private static final int FLAG_2 = 1;

    /**
     * the field number of CVV2Value (2)
     */
    private static final int CVV2_VALUE = 2;

    /**
     * Default counstructor
     */
    public CVV2Data() {
        super(FIELD_NUMBER);
    }
    
    /**
     * Sets flag1.
     * @param value the flag1 value
     * @throws ISOException if some exception occurs
     */
    public void setFlag1(String value) throws ISOException {
        set(FLAG_1, value);
    }

    /**
     * @return flag1
     */
    public String getFlag1() {
        return this.getString(FLAG_1);
    }
    
    /**
     * Sets flag2.
     * @param value the flag2 value
     * @throws ISOException if some exception occurs
     */
    public void setFlag2(String value) throws ISOException {
        set(FLAG_2, value);
    }

    /**
     * @return flag2
     */
    public String getFlag2() {
        return this.getString(FLAG_2);
    }
    
    /**
     * Sets CVV2.
     * @param value the CVV2 value
     * @throws ISOException if some exception occurs
     */
    public void setCVV2Value(String value) throws ISOException {
        set(CVV2_VALUE, value);
    }

    /**
     * @return CVV2 value
     */
    public String getCVV2Value() {
        return this.getString(CVV2_VALUE);
    }
}
