
package com.commtrain.PMS.iso;

import java.io.UnsupportedEncodingException;

import org.jpos.iso.ISOComponent;
import org.jpos.iso.ISOException;
import org.jpos.iso.ISOFieldPackager;

/**
 * ISOFieldPackager CHARACTERS (ASCII and BINARY)
 *
 * @author apr@cs.com.uy
 * @version $Id: IF_HOST_TEXT.java,v 1.1 2003/05/19 07:11:00 vangelov Exp $
 * @see ISOComponent
 */
public class IF_HOST_TEXT extends ISOFieldPackager {
    public static final int HOST_TEXT_LENGTH = 40;
    public IF_HOST_TEXT() {
	super();
    }
    /**
     * @param len - field len
     * @param description symbolic descrption
     */
    public IF_HOST_TEXT(String description) {
        super(HOST_TEXT_LENGTH, description);
    }
    /**
     * @param c - a component
     * @return packed component
     * @exception ISOException
     */
    public byte[] pack(ISOComponent c) throws ISOException {
        String s = (String) c.getValue();
        if (s.length() > getLength()) {
            s = s.substring(0, getLength());
        }
        try {
            return s.getBytes("ISO-8859-1");
        } catch (UnsupportedEncodingException e) {
            throw new ISOException(e);
        }
    }
    /**
     * @param c - the Component to unpack
     * @param b - binary image
     * @param offset - starting offset within the binary image
     * @return consumed bytes
     * @exception ISOException
     */
    public int unpack (ISOComponent c, byte[] b, int offset)
        throws ISOException
    {
        int len = b.length - offset;
        try {
            c.setValue(new String(b, offset, len, "ISO-8859-1"));
        } catch (UnsupportedEncodingException e) {
            throw new ISOException(e);
        }
        return len;
    }
    public int getMaxPackedLength() {
        return getLength();
    }
}
