package com.commtrain.PMS.iso;

import org.jpos.iso.ISOException;
import org.jpos.iso.ISOMsg;

/**
 * 
 */
public class PINResponseData extends ISOMsg {

    /**
     * the table id of PINResponseData ("92")
     */
    public static final String TABLE_ID = "92";

    /**
     * the field number of PINResponseData (92)
     */
    public static final int FIELD_NUMBER = 92;

    /**
     * the field number of customerServicePhoneNumber (0)
     */
    public static final int CUSTOMER_SERVICE_PHONE_NUMBER = 0;

    /**
     * the field number of mobilePhoneNumber (1)
     */
    public static final int MOBILE_PHONE_NUMBER = 1;

    /**
     * the field number of gsmProviderReferenceNo (2)
     */
    public static final int GSM_PROVIDER_REFERENCE_NO = 2;

    /**
     * the field number of gsmProviderMerchantID (3)
     */
    public static final int GSM_PROVIDER_MERCHANT_ID = 3;

    /**
     * Default counstructor
     */
    public PINResponseData() {
        super(FIELD_NUMBER);
    }
    
    /**
     * Sets customer service phone number
     * @param value customer service phone number
     * @throws ISOException if some exception occurs
     */
    public void setCustomerServicePhoneNumber(String value) throws ISOException {
        this.set(CUSTOMER_SERVICE_PHONE_NUMBER, value);
    }

    /**
     * Sets mobile phone number
     * @param value mobile phone number
     * @throws ISOException if some exception occurs
     */
    public void setMobilePhoneNumber(String value) throws ISOException {
        this.set(MOBILE_PHONE_NUMBER, value);
    }

    /**
     * Sets GSM provider reference number
     * @param value GSM provider reference number
     * @throws ISOException if some exception occurs
     */
    public void setGSMProviderReferenceNo(String value) throws ISOException {
        this.set(GSM_PROVIDER_REFERENCE_NO, value);
    }

    /**
     * Sets GSM provider merchant ID
     * @param value GSM provider merchant ID
     * @throws ISOException if some exception occurs
     */
    public void setGSMProviderMerchantID(String value) throws ISOException {
        this.set(GSM_PROVIDER_MERCHANT_ID, value);
    }
}
