package com.commtrain.PMS.iso;

import java.io.IOException;
import java.net.*;

import org.jpos.iso.*;
import org.jpos.iso.ISOFilter.VetoException;

/**
 * 
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class PayGatewayChannel extends BaseChannel {
	protected final static int EOM = 10;

    /**
     * Constructor for PayGatwayChannel.
     * @param host
     * @param port
     * @param p
     */
    public PayGatewayChannel(String host, int port, ISOPackager p) {
        super(host, port, p);
    }

    /**
     * Constructs server ISOChannel associated with a Server Socket
     * @param p
     * @param serverSocket
     * @throws IOException
     */
    public PayGatewayChannel(ISOPackager p, ServerSocket serverSocket) throws IOException {
        super(p, serverSocket);
    }

    /**
     * @see org.jpos.iso.BaseChannel#sendMessageTrailler(ISOMsg, int)
     */
    protected void sendMessageTrailler(ISOMsg m, int len) throws IOException {
    	serverOut.write(EOM);//Line Feed
    	//serverOut.write(13);//Carriage Return
    }

    /**
     * @see org.jpos.iso.BaseChannel#streamReceive()
     */
    protected byte[] streamReceive() throws IOException {//read 43 or 60 bytes
    	byte buffer[] = new byte[2000];
    	int cnt=0;
    	byte b;
    	while ((b = serverIn.readByte()) != EOM) {
    		buffer[cnt++] = b;
    		//System.out.println(buffer[cnt-1]+" "+(char)buffer[cnt-1]);
    	}
		
    	byte ret[] = new byte[cnt];
    	System.arraycopy(buffer, 0, ret, 0, cnt);
    	return ret;
    }
    /**
     * @see org.jpos.iso.BaseChannel#sendMessageLength(int)
     */
    protected void sendMessageLength(int len) throws IOException {
    }

    /**
     * @see org.jpos.iso.ISOSource#send(ISOMsg)
     */
    public void send(ISOMsg m) throws IOException, ISOException, VetoException {
        super.send(m);
    }



    /**
     * @see org.jpos.iso.BaseChannel#sendMessageHeader(ISOMsg, int)
     */
    protected void sendMessageHeader(ISOMsg m, int len) throws IOException {
    }

}
