package com.commtrain.PMS.isoBean;

import org.jpos.iso.ISOException;
import org.jpos.iso.ISOMsg;

/**
 * 
 */
public class AdditionalWebShopData extends ISOMsg {

    /**
     * the table id of AdditionalWebShopData ("WS")
     */
    public static final String TABLE_ID = "WS";

    /**
     * the field number of AdditionalWebShopData (103)
     */
    public static final int FIELD_NUMBER = 103;

    /**
     * the field number of noOfPos (0)
     */
    public static final int NO_OF_POS = 2;

    /**
     * the field number of noPos (1)
     */
    public static final int NO_POS = 3;

    /**
     * the field number of rayon (2)
     */
    public static final int RAYON = 4;

    /**
     * Constructor for AdditionalWebShopData.
     */
    public AdditionalWebShopData() {
        super(FIELD_NUMBER);
    }
    
    /**
     * Sets Number of postions in the ISO Request.
     * @param value number of postions in the ISO Request
     * @throws ISOException if some exception occurs
     */
    public void setNoOfPos(String value) throws ISOException {
        this.set(NO_OF_POS, value);
    }

    /**
     * @return number of postions in the ISO Request
     */
    public String getNoOfPos() {
        return this.getString(NO_OF_POS);
    }
    
    /**
     * Sets Postion number in the ISO Request.
     * @param value postion number
     * @throws ISOException if some exception occurs
     */
    public void setNoPos(String value) throws ISOException {
        this.set(NO_POS, value);
    }

    /**
     * @return postion number in the ISO Request
     */
    public String getNoPos() {
        return this.getString(NO_POS);
    }

    /**
     * Sets Rayon in the ISO Request.
     * @param value rayon
     * @throws ISOException if some exception occurs
     */
    public void setRayon(String value) throws ISOException {
        this.set(RAYON, value);
    }

    /**
     * @return rayon in the ISO Request
     */
    public String getRayon() {
        return this.getString(RAYON);
    }
}
