package com.commtrain.PMS.isoBean;

import org.apache.log4j.BasicConfigurator;
import org.apache.log4j.ConsoleAppender;
import org.apache.log4j.PatternLayout;
import org.jpos.iso.IFB_NUMERIC;
import org.jpos.iso.ISOBasePackager;
import org.jpos.iso.ISOException;
import org.jpos.iso.ISOFieldPackager;
import org.jpos.iso.ISOUtil;

import com.commtrain.PMS.logging.LogEntry;
import com.commtrain.PMS.iso.IF_NOP;

/**
 * 
 */
public class AdditionalWebShopDataPackager extends ISOBasePackager {

    private static org.apache.log4j.Logger logger = org.apache.log4j.Logger.getLogger(AdditionalWebShopDataPackager.class);

    /**
     * The definition of the packager
     * @see org.jpos.iso.ISOBasePackager
     */
    private ISOFieldPackager fld[] = {
        new IF_NOP(),
        new IFB_SIMPLE_BITMAP(8, "Bit map"),
        new IFB_NUMERIC(3, "Number of Postions", true),
        new IFB_NUMERIC(3, "Postion Number", true),
        new IFB_NUMERIC(2, "Rayon", true)
    };

    /**
     * Default constructor
     */
    public AdditionalWebShopDataPackager() {
        setFieldPackager(fld);
    }

    /**
     * Test
     * @throws ISOException if some exception occurs
     */
    public static void main(String args[]) throws ISOException {
        BasicConfigurator.configure(new ConsoleAppender(new PatternLayout("%m%n")));
        AdditionalWebShopDataPackager packager = new AdditionalWebShopDataPackager();
        AdditionalWebShopData originalMsg = new AdditionalWebShopData();
        AdditionalWebShopData repacketedMsg = new AdditionalWebShopData();
        byte[] packetedMsg;

        //Create message
        originalMsg.setNoOfPos("123");
        originalMsg.setNoPos("789");
        originalMsg.setRayon("5");
        logger.info(new LogEntry("Original mesage", originalMsg));
        originalMsg.setPackager(packager);

        //Pack it
        packetedMsg = originalMsg.pack();
        logger.info(new LogEntry("Packeted mesage", ISOUtil.hexString(packetedMsg)));

        //Unpack it
        repacketedMsg.setPackager(packager);
        repacketedMsg.unpack(packetedMsg);
        logger.info(new LogEntry("Repacketed mesage", repacketedMsg));
    }
}
