package com.commtrain.PMS.logging;

import java.text.DecimalFormat;

/**
 * 
 */
public class Statistics {
    private static final DecimalFormat AVG_FMT = new DecimalFormat("0.00"); 
    private int i;
    private int modulus;
    private String name;
    private int count;
    private long sum;
    private int current;
    private int max;
    
    public Statistics(String name, int modulus) {
        this.name = name;
        this.modulus = modulus;
        count = 0;
        sum = 0;
        current = 0;
        max = 0;
        i = 0;
    }
    
    public boolean addEvent(int value) {
        count++;
        i++;
        if (i == modulus) {
            i = 0;
        }
        current = value;
        sum += value;
        if (value > max) {
            max = value;
        }
        return i == 0;
    }

    /** @see java.lang.Object#toString() */
    public String toString() {
        if (count == 0) {
            throw new IllegalStateException("No statistics have been collected.");
        }
        StringBuffer result = new StringBuffer();
        result.append("Statistics of '")
        .append(name)
        .append("': count=").append(count)
        .append("; current=").append(current)
        .append("; max=").append(max)
        .append("; avg=").append(AVG_FMT.format(((double) sum) / ((double) count)));
        
        return result.toString();
    }

}
