package com.commtrain.PMS.transaction;

import com.commtrain.PMS.application.Application;

/**
 * 
 *
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class TransactionMapping {

    /** 
     * Reservation transaction type.
     */
    public static final int NOT_NUMBERED = -1;
    
  	public static final String HYPERCOM_REVERSAL_RESPONSE = "0410";

	
	
	private static final int RECORD_TYPE_POS 	= 0;
	private static final int CLIENT_TYPE_ID_POS	= 1;
	private static final int MTI_POS				= 2;
	private static final int PROCESS_CODE_POS = 3;
	private static final int TRANSACTION_CLASS_POS =4;
	
	
				    //recordType, 				ClientTypeID in IENHeader ,                  MTI, Proccesing Code,  Transaction implementation class name 
    protected final static String[][] codeMapping = {
    	
        { Integer.toString(100),		Integer.toString(Application.HYPERCOM_ID),	"0200", "000000", "com.commtrain.PMS.transaction.hypercom.OnlineSale" },
        { Integer.toString(101),		Integer.toString(Application.HYPERCOM_ID),	"0200", "020000", "com.commtrain.PMS.transaction.hypercom.Void" },
        { Integer.toString(80),		Integer.toString(Application.HYPERCOM_ID),	"0200", "400000", "com.commtrain.PMS.transaction.hypercom.Reservation" },
        { Integer.toString(90),		Integer.toString(Application.HYPERCOM_ID),	"0200", "410000", "com.commtrain.PMS.transaction.hypercom.ReservationCapture" }, 
        
    };

    /**
     * Method getISOCodes.
     * @param recordType
     * @return String[]{ClientTypeID, MTI, Proccesing Code}
     */
    public static String[] getClientAndISOCodes(String recordType) {
        for (int i = 0; i < codeMapping.length; i++) {
            if (codeMapping[i][RECORD_TYPE_POS].equals(recordType) && recordType!=Integer.toString(NOT_NUMBERED)) {
                return new String[] { codeMapping[i][CLIENT_TYPE_ID_POS], codeMapping[i][MTI_POS], codeMapping[i][PROCESS_CODE_POS] };
            }
        }
        return new String[] { null, null };
    }

    /**
     * Method getRecordType.
     * @param ClientType 
     * @param MTI
     * @param processingCode
     * @return String
     */
    public static String getRecordType(String clientType, String MTI, String processingCode) {
        for (int i = 0; i < codeMapping.length; i++) {
            if (codeMapping[i][CLIENT_TYPE_ID_POS].equals(clientType) && codeMapping[i][MTI_POS].equals(MTI) && processingCode!=null && processingCode.startsWith(codeMapping[i][PROCESS_CODE_POS])) {
                return codeMapping[i][RECORD_TYPE_POS];
            }
        }
        return null;
    }
    
    /*
     *
     */ 
    public static String getImplementationClassname(String clientType, String MTI, String processingCode){
        for (int i = 0; i < codeMapping.length; i++) {
            if (codeMapping[i][CLIENT_TYPE_ID_POS].equals(clientType) && codeMapping[i][MTI_POS].equals(MTI) && processingCode!=null && processingCode.startsWith(codeMapping[i][PROCESS_CODE_POS])) {
                return codeMapping[i][TRANSACTION_CLASS_POS];
            }
        }
        return null;
    }
}
