package com.commtrain.PMS.transaction.hypercom;

import com.commtrain.util.MessageCatalog;

/**
 * Message Package for Hypercom transactions
 * 
 * 
 */
public abstract class Messages {
    
    /**
     * Message catalog
     */
    private static MessageCatalog messageCatalog = new MessageCatalog(Messages.class);

    /**
     * Returns message catalog
     */
    public static MessageCatalog getInstance() {
        return messageCatalog;
    }
    
    private static final String SIGNATURE_PLEASE = "SIGNATURE_PLEASE";
    private static final String AMOUNT_TOO_HIGH = "AMOUNT_TOO_HIGH";
    private static final String REFERRAL = "REFERRAL";

    public static String getStringSignaturePlease(String localeDescription) {
        return getInstance().getString(SIGNATURE_PLEASE, localeDescription);
    }

    public static String getStringAmountTooHigh(String localeDescription) {
        return getInstance().getString(AMOUNT_TOO_HIGH, localeDescription);
    }

    public static String getStringReferral(String localeDescription) {
        return getInstance().getString(REFERRAL, localeDescription);
    }

//    public static void main(String[] args) {
//    	String s1 = getString("alabala", "1");
//    	String s2 = getStringAmountTooHigh("");
//    	String s3 = getStringAmountTooHigh("bg");
//    	String s4 = getStringAmountTooHigh("XYZ");
//    	String s5 = getStringAmountTooHigh("en");
//    	String s6 = getStringAmountTooHigh("de");
//    	String s7 = getStringAmountTooHigh("fr");
//    	String s8 = getStringAmountTooHigh("it");
//    	String s9 = getStringAmountTooHigh("de_CH");
//    	String sa = getStringAmountTooHigh("fr_CH");
//    	String sb = getStringAmountTooHigh("it_CH");
//    	String sc = getStringAmountTooHigh("it_XX");
//    	String sd = getStringAmountTooHigh("gyuvetch");
//    }
}
