package com.commtrain.PMS.transaction.hypercom;

import org.jpos.iso.ISOMsg;

import com.commtrain.PMS.transaction.OnlineTransaction;

/**
 * 
 * Base class for OnlineSale and MOTOSale
 */
public abstract class OnlineSaleBase extends OnlineTransaction {

    /**
     * Constructor for OnlineSaleBase.
     * @param isoRequest
     */
    public OnlineSaleBase(ISOMsg isoRequest) {
        super(isoRequest);
    }

    /**
     * Method getCustomCarResponseCode.
     * Handles responses with invalid combinations of 
     * @param carResponseCode
     * @param carRespIndicator
     * @return String
     */
    protected String getCustomCarResponseCode(String carResponseCode, String carRespIndicator){    	


        int carResNo = 0;
        int carRespIndicatorNo = 79;
        String changedCarResponseCode;
        try {
            carResNo = Integer.parseInt(carResponseCode);
        	carRespIndicatorNo = Integer.parseInt(carRespIndicator);
        } catch (NumberFormatException e) {
            carResNo = 79;
            carRespIndicatorNo = 0;
        }
        
        changedCarResponseCode=Integer.toString(carResNo);
        
        switch (carRespIndicatorNo) {
        	case 0:
	            if (carResNo != 1)
	                changedCarResponseCode = "79";
            	break;
        	case 10:
        		if(carResNo!=59 && carResNo!=60)
	                changedCarResponseCode = "79";
            	break;
        	case 20:
        	case 81:
        	default:
	                changedCarResponseCode = "79";
	            break;
        }
        if(changedCarResponseCode.length()==1)
			changedCarResponseCode = "0"+changedCarResponseCode;
    	return changedCarResponseCode;
    }
}
