/*
 * Created on 2003-9-18
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.commtrain.util;

import java.io.*;
import org.apache.log4j.BasicConfigurator;
import org.apache.log4j.ConsoleAppender;
import org.apache.log4j.PatternLayout;
/**
 * 
 */
public class NLSLineNumberReader extends LineNumberReader {
	private static org.apache.log4j.Logger logger = org.apache.log4j.Logger.getLogger(NLSLineNumberReader.class);
	private String fileEncoding = null;
	/**
	 * @param in
	 */
	private NLSLineNumberReader(Reader in) {
		super(in);
	}

	/**
	 * @param in
	 * @param sz
	 */
	private NLSLineNumberReader(Reader in, int sz) {
		super(in, sz);
	}

	public NLSLineNumberReader(String fileName)
		throws UnsupportedEncodingException, FileNotFoundException {
		this(fileName, "UTF-8");
	}

	public NLSLineNumberReader(String fileName, String fileEncoding)
		throws UnsupportedEncodingException, FileNotFoundException {
		this(
			new BufferedReader(
				new InputStreamReader(
					new BufferedInputStream(new FileInputStream(fileName)),
					fileEncoding)));
		this.fileEncoding = fileEncoding;
	}

	public NLSLineNumberReader(File file)
		throws UnsupportedEncodingException, FileNotFoundException {
		this(file, "UTF-8");
	}

	public NLSLineNumberReader(File file, String fileEncoding)
		throws UnsupportedEncodingException, FileNotFoundException {
		this(
			new BufferedReader(
				new InputStreamReader(
					new BufferedInputStream(new FileInputStream(file)),
					fileEncoding)));
		this.fileEncoding = fileEncoding;
	}

	public void close() throws IOException {
		super.close();
		
	}

	public static void main(String[] argv) {
		BasicConfigurator.configure(
			new ConsoleAppender(new PatternLayout("%m%n")));

		NLSLineNumberReader in = null;
		try {
			in = new NLSLineNumberReader(argv[0], argv[1]);
		} catch (UnsupportedEncodingException e) {
			logger.error("Could not open file: ", e);
		} catch (FileNotFoundException e) {
			logger.error("Could not open file: ", e);
		}
		String line = "";
		try {
			while ((line = in.readLine())!= null) {
				System.out.print(in.getLineNumber());
				System.out.print(": ");
				System.out.println(line);
				
			}
		} catch (IOException e) {
			logger.error("Error while reading file: ", e);
		} finally {
			try {
				in.close();
			} catch (IOException e) {
				logger.error("Error while closing file: ", e);
			}
		}
	}
}