/*
 * Created on 2003-9-18
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.commtrain.util;

import java.io.*;
import org.apache.log4j.BasicConfigurator;
import org.apache.log4j.ConsoleAppender;
import org.apache.log4j.PatternLayout;

/**
 * 
 */
public class NLSPrintWriter extends PrintWriter {
	private static org.apache.log4j.Logger logger = org.apache.log4j.Logger.getLogger(NLSPrintWriter.class);
	private String fileEncoding = null;

	private NLSPrintWriter(Writer out) {
		super(out);
	}

	/**
		* @param out
		* @param autoFlush
		*/
	private NLSPrintWriter(Writer out, boolean autoFlush) {
		super(out, autoFlush);
	}

	/**
		* @param out
		*/
	public NLSPrintWriter(OutputStream out)
		throws UnsupportedEncodingException {
		super(new OutputStreamWriter(out, "UTF-8"));
	}

	/**
		* @param out
		* @param autoFlush
		*/
	public NLSPrintWriter(OutputStream out, boolean autoFlush)
		throws UnsupportedEncodingException {
		super(new OutputStreamWriter(out, "UTF-8"), autoFlush);
		this.fileEncoding = "UTF-8";
	}

	public NLSPrintWriter(String fileName)
		throws UnsupportedEncodingException, FileNotFoundException {
		this(fileName, "UTF-8");
	}

	public NLSPrintWriter(String fileName, String fileEncoding)
		throws UnsupportedEncodingException, FileNotFoundException {
		super(
			new BufferedWriter(
				new OutputStreamWriter(
					(new FileOutputStream(fileName)),
					fileEncoding)));
		this.fileEncoding = fileEncoding;
	}

	public NLSPrintWriter(File file)
		throws UnsupportedEncodingException, FileNotFoundException {
		this(file, "UTF-8");
	}

	public NLSPrintWriter(File file, String fileEncoding)
		throws UnsupportedEncodingException, FileNotFoundException {
		super(
			new BufferedWriter(
				new OutputStreamWriter(
					(new FileOutputStream(file)),
					fileEncoding)));
		this.fileEncoding = fileEncoding;
	}

	public void close() {
		super.close();
		
	}
	public static void main(String[] argv) {
		BasicConfigurator.configure(
			new ConsoleAppender(new PatternLayout("%m%n")));

		NLSPrintWriter out = null;
		try {
			out = new NLSPrintWriter(argv[0], argv[1]);
		} catch (UnsupportedEncodingException e) {
			logger.error("Error opening file: ", e);
		} catch (FileNotFoundException e) {
			logger.error("Error opening file: ", e);
		}

		out.println("");
		out.println(
			"\u00C0\u00C1\u00C2\u00C3\u00C4\u00C5\u00C6\u00C7\u00C8\u00C9\u00CA\u00CB\u00CC\u00CD\u00CE\u00CF" +
			"\u00D0\u00D1\u00D2\u00D3\u00D4\u00D5\u00D6\u00D7\u00D8\u00D9\u00DA\u00DB\u00DC\u00DD\u00DE\u00DF");
		out.println(
			"\u00E0\u00E1\u00E2\u00E3\u00E4\u00E5\u00E6\u00E7\u00E8\u00E9\u00EA\u00EB\u00EC\u00ED\u00EE\u00EF" +
			"\u00F0\u00F1\u00F2\u00F3\u00F4\u00F5\u00F6\u00F7\u00F8\u00F9\u00FA\u00FB\u00FC\u00FD\u00FE\u00FF");
		out.close();

	}
}
