package com.commtrain.carcds;

import javax.servlet.*;
import java.sql.*;
import com.bitmechanic.sql.*;


public class InitPool extends GenericServlet {
	private static ConnectionPoolManager poolManager=null;
	private String poolName = "cds";

	public void init() throws javax.servlet.ServletException{
		ServletConfig config = getServletConfig();

		try{	
			if(poolManager==null){//Create manager
					// Check for stale connections every 2 minutes
					poolManager = new ConnectionPoolManager(120);
		//			System.out.println("Connection Pool Manager created!");
					try{
						Class.forName(config.getInitParameter("DBDriver")).newInstance();//Load Driver class once
					}catch(Exception e){
						System.err.println("DBDriver not loaded:");
						e.printStackTrace();
					}
			}
			
			if(poolManager!=null){
				try{
					poolManager.getPool(poolName);
				}catch(SQLException e){
					//Pool not defined
					poolManager.addAlias(poolName,
							config.getInitParameter("DBDriver"),
							config.getInitParameter("DBURL"),
							config.getInitParameter("DBUserName"),
							config.getInitParameter("DBPassword"),
							Integer.parseInt(config.getInitParameter("DBMaximumConnections")),
							Integer.parseInt(config.getInitParameter("DBIdleTimeout")),
							Integer.parseInt(config.getInitParameter("DBCheckoutTimeout")));
		//			System.out.println("Pool added for "+DBUserName);
				}
			}
		}catch(Exception e){
			System.err.println("Error while creating jdbc connection pool:");
			e.printStackTrace();
		}
	}
	public void service(ServletRequest request, ServletResponse response){
		
	}
	public static void main(String argv[]){
		System.out.println(ConnectionPoolManager.URL_PREFIX);
	}
}
