package com.commtrain.carcds;
import java.io.*;
import javax.servlet.http.*;
import java.util.*;
/**
 * Properties holder. Each user has a different props object stored in his session.
 * Normally it is created only once - on login time (PostLogin.jsp).
 * Standard property keys are: <BR><BR>
<table BORDER="1" CELLPADDING="3" CELLSPACING="0" WIDTH="100%">
<tr><th>     key      </th><th>Description</th></tr>
<tr><td>"applicationPath"</td><td>Application Prefix (ex /Test )</td></tr>
<tr><td>"helpSetsOSURI"</td><td>OS Directory containing JavaHelp helpSets (ex "file:/C:/NIMSoftFiles/public/HelpSets/")</td></tr>
<tr><td>"helpSetsURL"</td><td>URL Directory containing JavaHelp helpSets (ex "/public/HelpSets/")</td></tr>
</table>
<BR>
 * Creation date: (7/4/2001 11:10:45 AM)
 * @author: 
 */
public class Props{
	protected Map propMap = new HashMap();
	private static String[] keyNames = {"applicationPath", "helpSetsOSURI","helpSetsURL"};

	public Props(HttpServletRequest request){
		String serverName = request.getServerName();
		String applicationPath = request.getContextPath();
		String resourceFilename = serverName + "."+applicationPath.substring(1) + ".properties";
		PropertyResourceBundle resourceBundle;

		try{
			ClassLoader loader = Props.class.getClassLoader();
			InputStream inp = loader.getResourceAsStream(resourceFilename);
			resourceBundle = new PropertyResourceBundle(inp);
		}catch(Exception e){
			e.printStackTrace();
			System.err.println("Resource file:"+resourceFilename+" Not Found!");
			return;
		}

		try{
			for(int i=0;i<keyNames.length;i++){
				String value = resourceBundle.getString(keyNames[i]);
				setProperty(keyNames[i],value);
			}
		}catch(MissingResourceException e ){
			System.err.println(e + " in "+resourceFilename);
		}
		
/*		String internalDirOSURI = "file:/C:/NIMSoftFiles/internal";
		
		setProperty("applicationPath",applicationPath);
		setProperty("actionHandleJsp",applicationPath + "/NIMSoft/ActionHandle.jsp");
		setProperty("downloadJsp",applicationPath + "/NIMSoft/Download.jsp");
		setProperty("userInfoJsp",applicationPath + "/NIMSoft/Admin/UserInfo.jsp");
		setProperty("masterCss",applicationPath + "/theme/Master.css");
		setProperty("ContextNavigationCss",applicationPath + "/theme/ContextNavigation.css");
		setProperty("classpathDirOSURI",internalDirOSURI+"/ClassPath");
		setProperty("internalDirOSURI",internalDirOSURI);
		setProperty("publicDirOSURI","file:/C:/NIMSoftFiles/public");
		setProperty("publicDirURLPathAlias","/public");
		setProperty("helpSetsOSURI",internalDirOSURI+"/HelpSets");*/
		if(! request.getServletPath().equals("/Navigation/PostLogin.jsp"))
			System.out.println("Warning: Props object created in "+request.getServletPath());
	}


/**
 * Get property.
 * Creation date: (8/1/2001 12:42:47 PM)
 * @param key java.lang.String
 */
public String getProperty(String key) {
	return (String)propMap.get(key);
}


/**
 * Set property.
 * Creation date: (8/1/2001 12:42:47 PM)
 * @param key java.lang.String
 * @param value java.lang.String
 */
public void setProperty(String key, String value) {
	if(key!=null)
		propMap.put(key,value);
}
}