package com.commtrain.carcds;
import javax.servlet.*;
import java.text.*;

public class SearchUtil {

	//Parameters Check

	public boolean NullParametersState;
	public boolean NoExistantParametersState;
	public boolean[] parameterExistency = new boolean[0];

	//Edn Parameters Check

	public static final int equalSearchType = 0; // "=" for any type of fields
	public static final int likeSearchType = 1; // "~string" uses the like clause
	public static final int firstLetterSearchType = 2; // "~string%" like clause plus a wildcard at the end of the string
	public static final int startIntervalSearchType = 3; //">the_value"
	public static final int endIntervalSearchType = 4; // "<the_value"
	public static final int startDateSearchType = 5; // for date columns
	public static final int endDateSearchType = 6; // for date columns
	public static final int startIntDateSearchType = 7;
	public static final int endIntDateSearchType = 8;
	public static final int startIntTimeSearchType = 9;
	public static final int endIntTimeSearchType = 10;
	public static final int startTimeSearchType = 11;
	public static final int endTimeSearchType = 12;
	public static final int freeIntSearch = 13;
	public static final int wildCardSearchType = 14;
	public static final int isNullSearchType = 15;
	public static final int isNotNullSearchType = 16;
	
	public static final String ISNULL="NULL";
	public static final String ISNOTNULL="NOT NULL";
	
	public static final String mandatoryFilter = ",";
	public static final String optionalFilter = ",|";
	protected String filterOptionality = mandatoryFilter;

	public static final String userDateFormat = "dd.mm.yyyy";
	public static final String dbIntDateFormat = "yyyymmdd";
	public static final String userTimeFormat = "HH:mm";
	public static final String dbIntTimeFormat = "HHmm";
	public static final String ORATimeFormat = "HH24:MI";
	public static final String ORADetailTimeFormat = "HH24:MI:SS";

	protected final String equalCompare = "=";
	protected final String notEqualCompare = "<>";
	protected final String equalGreaterCompare = ">=";
	protected final String equalLessCompare = "<=";
	protected final String greaterCompare = ">";
	protected final String lessCompare = "<";
	protected final String likeCompare = "~";
	protected final String wildCardPattern = "%";
	protected final String singleLetterPattern = "_";
	protected final String isNullPattern = "IS NULL";
	protected final String isNotNullPattern="IS NOT NULL";
	
	private String compareFilter(String fieldValue, boolean intValue) throws Exception {

		String searchValue = fieldValue;
		String compareSymbol = equalCompare;

		if (fieldValue.startsWith(equalGreaterCompare) || fieldValue.startsWith(equalLessCompare)) {
			compareSymbol = fieldValue.substring(0, 2);
			searchValue = fieldValue.substring(2);
		} else if (fieldValue.startsWith(greaterCompare) || fieldValue.startsWith(lessCompare)) {
			compareSymbol = fieldValue.substring(0, 1);
			searchValue = fieldValue.substring(1);
		}

		if (intValue)
			searchValue = Long.parseLong(searchValue) + "";

		return (compareSymbol + searchValue);
	}
	
	
	private String strFilter(String strValue) throws Exception{
		
		if (strValue.indexOf(equalCompare)!=-1 || strValue.indexOf(greaterCompare)!=-1 || strValue.indexOf(lessCompare)!=-1)
			throw new Exception("Uncorrect String Parameter!");
			
		return strValue;
	}
	public void setFilterOptionality(String filterOptionality) {
		this.filterOptionality = filterOptionality;
	}
	public String convertUserDateToInt(String date) throws Exception {
		return dateConverter(date, userDateFormat, dbIntDateFormat);
	}
	public static String dateConverter(String date, String oldformat, String newformat) throws Exception {
		//String newDate = date;
		//try{
		SimpleDateFormat formatter = new SimpleDateFormat(oldformat);
		java.util.Date currentDate = formatter.parse(date);
		formatter = new SimpleDateFormat(newformat);
		//newDate = formatter.format(currentDate);
		////}catch(Exception e){}
		return formatter.format(currentDate);

	}
	public boolean[] checkParamExist(ServletRequest request, String[] paramNames) {

		boolean nullResult = true;
		boolean noexistency = true;
		boolean equalsNull = true;
		boolean equalsEmtyString = true;

		if (paramNames == null) {

			NullParametersState = true;
			NoExistantParametersState = true;
			parameterExistency = new boolean[0];
			return parameterExistency;
		}

		boolean[] existState = new boolean[paramNames.length];
		String paramValue = null;

		for (int i = 0; i < paramNames.length; i++) {

			paramValue = request.getParameter(paramNames[i]);
			equalsNull = paramValue == null;
			equalsEmtyString = "".equals(paramValue);

			nullResult = nullResult && equalsNull;
			noexistency = noexistency && (equalsNull || equalsEmtyString);
			existState[i] = !equalsNull && !equalsEmtyString;
		}

		NullParametersState = nullResult;
		NoExistantParametersState = noexistency;
		parameterExistency = existState;

		return existState;
	}
	public String[] getParamValues(ServletRequest request, String[] paramNames,boolean use_trim) {

		boolean nullResult = true;
		boolean noexistency = true;
		boolean equalsNull = true;
		boolean equalsEmtyString = true;
		boolean[] existState = new boolean[0];
		String[] paramValues = new String[0];
		try {
			if (paramNames == null) {

				NullParametersState = true;
				NoExistantParametersState = true;
				parameterExistency = new boolean[0];
				return new String[0];
			}

			existState = new boolean[paramNames.length];
			paramValues = new String[paramNames.length];
			String paramValue = null;

			for (int i = 0; i < paramNames.length; i++) {

				paramValue = request.getParameter(paramNames[i]);
				equalsNull = paramValue == null;
				if (!equalsNull && use_trim)
					paramValue = paramValue.trim();
				equalsEmtyString = "".equals(paramValue);
				paramValues[i] = paramValue;

				nullResult = nullResult && equalsNull;
				noexistency = noexistency && (equalsNull || equalsEmtyString);
				existState[i] = !equalsNull && !equalsEmtyString;
			}

			NullParametersState = nullResult;
			NoExistantParametersState = noexistency;
			parameterExistency = existState;

		} catch (Exception e) {
			System.out.println("Exception in getParameters: " + e);
		}
		return paramValues;
	}
	public String calcSearchFilterString(int[] searchTypes, String[] paramValues, String[] fieldNames) {
		return calcSearchFilterString(searchTypes, paramValues, fieldNames, new boolean[0], dbIntDateFormat, userDateFormat, userTimeFormat, dbIntTimeFormat);
	}
	public String calcSearchFilterString(int[] searchTypes, String[] paramValues, String[] fieldNames, boolean[] optionality) {
		return calcSearchFilterString(searchTypes, paramValues, fieldNames, optionality, dbIntDateFormat, userDateFormat, userTimeFormat, dbIntTimeFormat);
	}
	public String calcSearchFilterString(int[] searchTypes, String[] paramValues, String[] fieldNames, String userDateFormat, String dbIntDateFormat) {
		return calcSearchFilterString(searchTypes, paramValues, fieldNames, new boolean[0], dbIntDateFormat, userDateFormat, userTimeFormat, dbIntTimeFormat);
	}
	public String calcSearchFilterString(int[] searchTypes, String[] paramValues, String[] fieldNames, boolean[] optionality, String dbIntDateFormat, String userDateFormat, String userTimeFormat, String dbIntTimeFormat) {

		boolean comlexFilter = optionality.length != 0;
		StringBuffer filterStr = new StringBuffer();

		for (int i = 0; i < paramValues.length; i++) {
			if (parameterExistency[i]) {
				int currentSearchType = searchTypes[i];
				if (filterStr.length() > 0) {
					if (!comlexFilter) {
						filterStr.append(filterOptionality);
					} else {
						if (optionality[i])
							filterStr.append(optionalFilter);
						else
							filterStr.append(mandatoryFilter);
					}
				}
				if (ISNOTNULL.equals(paramValues[i]))
					currentSearchType=isNotNullSearchType;
				if (ISNULL.equals(paramValues[i]))
					currentSearchType=isNullSearchType;	
				try {
					switch (currentSearchType) {

						case likeSearchType :
							{
								filterStr.append(fieldNames[i] + likeCompare + strFilter(paramValues[i]));
								break;
							}
						case wildCardSearchType :
							{
								filterStr.append(fieldNames[i] + likeCompare + wildCardPattern + strFilter(paramValues[i]) + wildCardPattern);
								break;
							}
						case firstLetterSearchType :
							{
								filterStr.append(fieldNames[i] + likeCompare + strFilter(paramValues[i]) + wildCardPattern);
								break;
							}
						case startIntervalSearchType :
							{
								filterStr.append(fieldNames[i] + equalGreaterCompare + Long.parseLong(paramValues[i]));
								break;
							}
						case endIntervalSearchType :
							{
								filterStr.append(fieldNames[i] + equalLessCompare + Long.parseLong(paramValues[i]));
								break;
							}
						case startDateSearchType :
							{
								filterStr.append(fieldNames[i] + equalGreaterCompare + "TO_DATE('" + paramValues[i] + "','" + userDateFormat + "')");
								break;
							}
						case endDateSearchType :
							{
								filterStr.append(fieldNames[i] + equalLessCompare + "TO_DATE('" + paramValues[i] + " 23:59:59','" + userDateFormat +" "+ORADetailTimeFormat+ "')");
								break;
							}
						case startTimeSearchType :
							{
								filterStr.append("TO_DATE(TO_CHAR("+fieldNames[i]+",'"+ORATimeFormat+"'),'"+ORATimeFormat+"')" + equalGreaterCompare + "TO_DATE('" + paramValues[i] + "','" + ORATimeFormat + "')");
								break;
							}
						case endTimeSearchType :
							{
								filterStr.append("TO_DATE(TO_CHAR("+fieldNames[i]+",'"+ORATimeFormat+"'),'"+ORATimeFormat+"')" + equalLessCompare + "TO_DATE('" + paramValues[i] + "','" + ORATimeFormat + "')");
								//filterStr.append(fieldNames[i] + equalLessCompare + "TO_DATE('" + paramValues[i] + "','" + ORATimeFormat + "')");
								break;
							}
						case startIntDateSearchType :
							{
								filterStr.append(fieldNames[i] + equalGreaterCompare + dateConverter(paramValues[i], userDateFormat, dbIntDateFormat));
								break;
							}
						case endIntDateSearchType :
							{
								filterStr.append(fieldNames[i] + equalLessCompare + dateConverter(paramValues[i], userDateFormat, dbIntDateFormat));
								break;
							}
						case startIntTimeSearchType :
							{
								filterStr.append(fieldNames[i] + equalGreaterCompare + dateConverter(paramValues[i], userTimeFormat, dbIntTimeFormat));
								break;
							}
						case endIntTimeSearchType :
							{

								filterStr.append(fieldNames[i] + equalLessCompare + dateConverter(paramValues[i], userTimeFormat, dbIntTimeFormat));
								break;
							}
						case freeIntSearch :
							{

								filterStr.append(fieldNames[i] + compareFilter(paramValues[i], true));
								break;
							}
							case isNotNullSearchType :
							{

								filterStr.append(fieldNames[i] +" " +isNotNullPattern);
								break;
							}
							case isNullSearchType :
							{

								filterStr.append(fieldNames[i] +" " +isNullPattern);
								break;
							}

						default :
						case equalSearchType :
							{
								filterStr.append(fieldNames[i] + equalCompare + paramValues[i]);
								break;
							}
					}
				} catch (Exception e) {
					//System.out.println("Exception in Calculate filterString: " + e);
					filterStr = new StringBuffer("");
					break;
				}
			}
		}

		return filterStr.toString();
	}
}