package com.commtrain.carcds;
import javax.servlet.*;
import javax.servlet.http.*;

public class Util {
	public static final String emptyString = String.valueOf((char) 0X00A0);
	public static final int emptyStringRepeat = 14;

	public static final String ICE4000Model = "ICE-4000";
	public static final String ICE5500Model = "ICE-5500";
	public static final String WebTerminalModel = "WEB TERMINAL";
	public static final String DiePostTerminalModel = "POST TERMINAL";
	//public static final String OCHTerminalModel = "OCH TERMINAL";
	
	public static final String NONE_Appl_num = "-1";
	public static final String CarCds_Trm_Appl_num = "0";
	public static final String Telco_Trm_Appl_num = "1";
	public static final String Both_Appl_num = "2";
	
	public static final	String[] default_languages = {"de_CH","fr_CH","it_CH","en_US"};
	
	public static final String HypercomTRMManufacurer = "Hypercom";
	public static final String CCSTRMManufacurer = "CCS";
	
	public static final String CommtrainTRMSupplier = "COMMTRAIN";
	public static final String TsystemsTRMSupplier = "T-SYSTEMS";
	
	public static final String CustomerTestType = "0";
	public static final String CustomerProductionType = "1";
	
	public static final String TRMVersion = "_CHC8S_.11R";
	
	public static final String VALID_ENTITY = "1";
	public static final String INVALID_ENTITY = "2";
	
	public static final String COMM_METHOD_IEN = "0";		// IEN Routing table
	public static final String COMM_METHOD_IP = "1";		// Direct IP communication
	public static final String COMM_METHOD_X25 = "2";		// Direct X25 communication
	public static final String COMM_METHOD_ISDN = "3";	// Direct ISDN communication
	public static final String COMM_METHOD_MQ = "4";		// MQ Series message queues
	public static final String COMM_METHOD_UNKNOWN = "-1";// Unknown
	
	public static final String TRMConnectorNumber1="1";
	public static final String TRMConnectorNumber2="2";
	public static final String TRMConnectorNumber3="3";	
	
	public static final String TRMConnectorRJ45="RJ-45";	
	public static final String TRMConnectorTT83="TT-83";
	public static final String TRMConnector4Pol="4Pol";	
	
	public static final String TRMInitializeNumber="4";
	public static final String TRMNotInitializeNumber="0";
	
	public static final String TRMFeatureExclude="0";
	public static final String TRMFeatureInclude="1";
	
	public static final String defaultLanguage="de_CH";
		
	public static final String BatchStatusOK="50";
	public static final String BatchStatusFailed="65";
	
	public static final String sessionUserParam = "com.commtrain.security.user";
	public static final String sessionPropsParam = "com.commtrain.carcds.props";
	public static final String sessionLocaleParam = "org.dbforms.LOCALE";
	
	public static String calcNavAddOn(String[] paramNames, String[] paramValues){
		return calcNavAddOn(paramNames,paramValues,"?");
	}	
	public static String calcNavAddOn(String[] paramNames, String[] paramValues,String startSymbol){
		
		StringBuffer urlAddOn = new StringBuffer();
		
		if (paramNames==null || paramValues==null)
			return urlAddOn.toString();
		for (int i = 0; i < paramNames.length; i++) {
			
			if (paramValues[i] != null && !"".equals(paramValues[i])) {
				if (urlAddOn.length() > 0)
					urlAddOn.append("&");
				else 
					urlAddOn.append(startSymbol);	
				urlAddOn.append(paramNames[i] + "=" + paramValues[i]);
			}
		}
		return urlAddOn.toString();
		
	}
	public static String stingPower(String str, int repeat_number) {

		StringBuffer str_buffer = new StringBuffer();
		if ((str == null) || ("".equals(str)))
			return str;
		for (int i = 0; i < repeat_number; i++) {
			str_buffer.append(str);
		}

		return str_buffer.toString();
	}
	public static String calcMixedFilterString(ServletRequest request,String[] paramNames, String[] paramValues, String[] fieldNames) {
		
		String resultFilter="";
		String firstFilter = calcFilterStringByValues(paramValues,fieldNames);
		String secondFilter = calcFilterString(request,paramNames,fieldNames);
		if (firstFilter.length() > 0 && secondFilter.length()>0)
			resultFilter = firstFilter+";"+secondFilter;
		else 	
			resultFilter = firstFilter+secondFilter;
			
		return resultFilter;	
	}
	public static String calcFilterStringByValues(String[] paramValues, String[] fieldNames) {
		return calcFilterString(null, new String[0],paramValues, fieldNames,true);
	}	
	public static String calcFilterString(ServletRequest request, String[] paramNames, String[] fieldNames) {
		return calcFilterString(request, paramNames, new String[0], fieldNames,false);
	}	
	public static String calcFilterString(ServletRequest request, String[] paramNames, String[] paramValues, String[] fieldNames,boolean useValues) {
		
		String param = null;
		StringBuffer filterStr = new StringBuffer();
		
		if (paramNames==null || paramValues==null || fieldNames==null)
			return filterStr.toString();
			
		for (int i = 0; i < fieldNames.length; i++) {
			if (useValues)
				param = paramValues[i];
			else	
				param = request.getParameter(paramNames[i]);
				
			if (param != null && !"".equals(param)) {
				if (filterStr.length() > 0)
					filterStr.append(";");
				filterStr.append(fieldNames[i] + "=" + param);
			}
		}
		
		return filterStr.toString();
	}
	public static String dateConverter(String oldDate,String oldFormat, String newFromat){
		String newDate="";
		try{
			newDate = SearchUtil.dateConverter(oldDate,oldFormat,newFromat);
		}catch(Exception e){
				newDate=oldDate;
		}
		return newDate;	
	}
	public static String dateConverter(String oldDate){
		return dateConverter(oldDate,SearchUtil.dbIntDateFormat,SearchUtil.userDateFormat);
	}
	public static String timeConverter(String oldTime){
		String tempTime="";
		
		try{
			StringBuffer buffer = new StringBuffer();
			int strLength=oldTime.length();
			if (strLength>0 && strLength<4){
				for (int i=0;i<(4-strLength);i++)
					buffer.append("0");
				buffer.append(oldTime);
				tempTime=buffer.toString();	
			}else{
				tempTime=oldTime;
			}
				
		}catch(Exception e){
			return oldTime;
		}
		return dateConverter(tempTime,SearchUtil.dbIntTimeFormat,SearchUtil.userTimeFormat);
	}
	public static String htmlNormalize(String s) {
		StringBuffer str = new StringBuffer();
		if ((s == null) || ("".equals(s)))
			return s;
		else {
			int len = (s != null) ? s.length() : 0;
			for (int i = 0; i < len; i++) {
				char ch = s.charAt(i);
				switch (ch) {
					case '<' :
						{
							str.append("&lt;");
							break;
						}
					case '>' :
						{
							str.append("&gt;");
							break;
						}
					case '&' :
						{
							str.append("&amp;");
							break;
						}
					case '"' :
						{
							str.append("&quot;");
							break;
						}
					case '\r' :
					case '\n' :
						{
							str.append("&#");
							str.append(Integer.toString(ch));
							str.append(';');
							break;
						}
					default :
						{
							str.append(ch);
						}
				}
			}

			return str.toString();
		}
	} // normalize(String):String

}