package com.commtrain.sql;

import java.sql.*;
/**
 * Base abstract class for every class representing row in the relational table
 * Creation date: (19/02/2001 13:07:23)
 * @author: Ivo Penev
 */
public abstract class Table {
	protected SQLHelper sqlHelper;
	protected String dbTableName;
/**
 * Table constructor comment.
 */

protected Table(SQLHelper sqlHelper, String dbTableName) {
	this.sqlHelper = sqlHelper;
	this.dbTableName=dbTableName;
}

/**
 * Retrieves value of the column specified by columnName from the ASSET_TYPE table for this assettype
 * Creation date: (15/02/2001 15:22:43)
 * @return String
 */
protected Object getColumnValue(String columnName, String searchCondition) {
	Connection selectConnection=null;
	Statement stmt=null;
	ResultSet rs =null;
	Object ret=null;

try{
	selectConnection= sqlHelper.getConnection();
	StringBuffer querryStringBuffer = new StringBuffer(50);
	querryStringBuffer.append("SELECT ");
	querryStringBuffer.append(columnName);
	querryStringBuffer.append(" FROM ");
	querryStringBuffer.append(dbTableName);
	querryStringBuffer.append(" WHERE ");
	querryStringBuffer.append(searchCondition);
	
//"SELECT "+columnName+" FROM "+dbTableName+" WHERE "+searchCondition
		stmt = selectConnection.createStatement();
		rs = stmt.executeQuery(querryStringBuffer.toString());
		
		if(!rs.next())
			return null;
		ResultSetMetaData rsMeta = rs.getMetaData();
		String typeName = rsMeta.getColumnTypeName(1);
		if(typeName.equals("CLOB"))
			ret = rs.getString(1);
		else
			ret= rs.getObject(1 );

	} catch (Throwable e) {
		e.printStackTrace();
		return null;
	}finally {
		try{
			if(rs!=null)rs.close();
			if(stmt!=null)stmt.close();
		}catch(Exception e){
		}
		try{
			if(selectConnection!=null)
				selectConnection.close();
		}catch(Exception e){
		}
	}	
	
	return ret;
}
/**
 * Retrieves all values of the column specified by columnName from the ASSET_TYPE table for this assettype
 * Creation date: (04/04/2001 14:05:51)
 * @return Object[]
 */
protected Object[] getColumnValues(String columnName, String searchCondition) {
	return sqlHelper.getColumnFromTable(columnName,dbTableName,searchCondition);
}
/**
 * Sets value of the column specified by columnName from the ASSET_TYPE table for this assettype
 * Creation date: (15/02/2001 15:22:43)
 * @return String
 */
protected boolean setColumnValue(String columnName, Object value, String searchString) {

	return sqlHelper.setColumnValue(columnName,dbTableName,value,searchString);
}
}
