package com.commtrain.tag;

import java.io.*;
import java.sql.*;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import org.dbforms.util.*;
import org.dbforms.*;

import org.apache.log4j.Category;

public class ComGetConnection extends BodyTagSupport {

	static Category logCat = Category.getInstance(ComGetConnection.class.getName());
	// logging category for this class
		
	private String id;
	private Connection con;

	public int doStartTag() throws JspException {

		try {

			// Place connection in attribute
			pageContext.setAttribute(this.getId(), con, PageContext.PAGE_SCOPE);

		} catch (Exception e) {
			throw new JspException("Database error" + e.toString());
		}

		return EVAL_BODY_TAG;
	}

	public int doAfterBody() {
		try {
			bodyContent.writeOut(bodyContent.getEnclosingWriter());
		} catch (IOException ioe) {
			ioe.printStackTrace();
		}
		return SKIP_BODY;
	}

	/**
	 * Gets the id
	 * @return Returns a String
	 */
	public String getId() {
		return id;
	}
	/**
	 * Sets the id
	 * @param id The id to set
	 */
	public void setId(String id) {
		this.id = id;
	}
	public int doEndTag() throws JspException {
		
		release();
		return EVAL_PAGE;
	}

	public void release() {
		super.release();

		// The connection should not be null - If it is, then you might have an infrastructure problem!
		// Be sure to look into this!  Hint: check out your pool manager's performance! 

		if (con != null) {
			try {
				logCat.debug("About to close connection - " + con);
				con.close();
				logCat.debug("Connection closed");
			} catch (java.sql.SQLException sqle) {
				logCat.error("Exception: ",sqle);
			}
		}
		//logCat.debug("Connection closed");
	}

	public void setPageContext(PageContext pc) {
		super.setPageContext(pc);
		DbFormsConfig config =
			(DbFormsConfig) pageContext.getServletContext().getAttribute(
				DbFormsConfig.CONFIG);

		if (config == null)
			throw new IllegalArgumentException("Troubles with DbForms config xml file: can not find CONFIG object in application context! check system configuration! check if application crashes on start-up!");

		DbConnection aDbConnection = config.getDbConnection();

		if (aDbConnection == null)
			throw new IllegalArgumentException("Troubles in your DbForms config xml file: DbConnection not properly included - check manual!");

		con = aDbConnection.getConnection();
		logCat.debug("Created new connection - " + con);

		if (con == null)
			throw new IllegalArgumentException(
				"JDBC-Troubles: was not able to create connection, using the following DbConnection:"
					+ aDbConnection.toString());
	}

}