package com.commtrain.tag;

import org.dbforms.taglib.DbFormTag;
import java.util.*;
import javax.servlet.http.*;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;

import org.dbforms.*;
import org.dbforms.util.*;

import org.apache.log4j.Category;

public class ComSortTag extends TagSupport {

  static Category logCat = Category.getInstance(ComSortTag.class.getName()); // logging category for this class

  private DbFormsConfig config;
  private String fieldName;
  private Field field;
  private String sortType="desc"; // other possibillities asc = Ascending, none = None
  private boolean hidden=false;

	private DbFormTag parentForm;


  public void setFieldName(String fieldName) {
	this.fieldName=fieldName;
		this.field = parentForm.getTable().getFieldByName(fieldName);
   }
   public void setSortType(String defaultSortType) {
	this.sortType = defaultSortType;
   }      
	public String getSortType() {
	return sortType;
  }
   public void setHidden(boolean hidden) {
	this.hidden = hidden;
   }      
	public boolean getHidden() {
	return hidden;
  }    
	
  public String getFieldName() {
	return fieldName;
  }  

/*
  public int doStartTag() throws javax.servlet.jsp.JspException {
	return SKIP_BODY;
  }*/


  public int doEndTag() throws javax.servlet.jsp.JspException {
		try {
			
		
			int tableId = parentForm.getTable().getId();
			int fieldId = field.getId();


			if(!field.isKey() && !field.isFieldSortable())
				logCat.warn("you should declare "+field.getName()+" as key or as sortable in your config file, if you use it as ordering field!");

			HttpServletRequest request = (HttpServletRequest) pageContext.getRequest();

			StringBuffer paramNameBuf = new StringBuffer("sort_");
			paramNameBuf.append(tableId);
			paramNameBuf.append("_");
			paramNameBuf.append(fieldId);
			String paramName = paramNameBuf.toString();
			String oldValue = ParseUtil.getParameter(request, paramName);
			
			if (oldValue==null)	{		
				if (sortType.equals("asc"))
						oldValue = "asc";
				else if (sortType.equals("none"))
						oldValue = "none";
					 else
					 	oldValue = "desc";	
			}			
			
			StringBuffer tagBuf = new StringBuffer();
			if (hidden){
				tagBuf.append("<input type=\"hidden\" name=\""+paramName+"\" value=\""+oldValue+"\">");
			}else{
			tagBuf.append("<select name=\"");
			tagBuf.append(paramName);
			tagBuf.append("\" size=\"0\" onChange=\"javascript:document.dbform.submit()\" >");

			String strAsc = "Ascending", strDesc = "Descending", strNone ="None";
			
			// Internationalization			
			if( parentForm.getCaptionResource().equals("true") ) {
		 		Locale reqLocale =  MessageResources.getLocale(request);

				// get message resource or if null take the default (english)
				strAsc = MessageResources.getMessage("dbforms.select.sort.ascending", reqLocale, "Ascending");
				strDesc = MessageResources.getMessage("dbforms.select.sort.descending", reqLocale, "Descending");
				strNone = MessageResources.getMessage("dbforms.select.sort.none", reqLocale, "None");
			}
			/*if (oldValue==null)	{		
				if (sortType.equals("asc"))
						oldValue = "asc";
				else if (sortType.equals("none"))
						oldValue = "none";
					 else
					 	oldValue = "desc";	
			}*/
							
			// ---- ascending ----
			tagBuf.append("<option value=\"asc\"");
			if("asc".equals(oldValue)) {
				tagBuf.append(" selected ");
			}
			
			tagBuf.append(">").append( strAsc );

			// ---- descending ----
			tagBuf.append("<option value=\"desc\"");
			if("desc".equals(oldValue)) {
				tagBuf.append(" selected ");
			}

			tagBuf.append(">").append( strDesc );

			// ---- no sorting ----
			tagBuf.append("<option value=\"none\" ");
			if("none".equals(oldValue)) {
				tagBuf.append(" selected ");
			}

			tagBuf.append(">").append( strNone );

			tagBuf.append("</select>");
			}
			pageContext.getOut().write(tagBuf.toString());

		} catch(java.io.IOException ioe) {
	  throw new JspException("IO Error: "+ioe.getMessage());
		}
		return EVAL_PAGE;
  }  


  public void setPageContext(final javax.servlet.jsp.PageContext pageContext)  {
	super.setPageContext(pageContext);
		this.config = (DbFormsConfig) pageContext.getServletContext().getAttribute(DbFormsConfig.CONFIG);
	}

  public void setParent(final javax.servlet.jsp.tagext.Tag parent) {
	super.setParent(parent);
	this.parentForm = (DbFormTag) findAncestorWithClass(this, DbFormTag.class);
  }  


}

